package com.ubains.rtspdemo;

import androidx.appcompat.app.AppCompatActivity;

import android.os.Build;
import android.os.Bundle;
import android.transition.Explode;
import android.view.View;
import android.view.Window;
import android.view.WindowManager;

import com.shuyu.gsyvideoplayer.GSYVideoManager;
import com.shuyu.gsyvideoplayer.cache.CacheFactory;
import com.shuyu.gsyvideoplayer.cache.ProxyCacheManager;
import com.shuyu.gsyvideoplayer.listener.GSYSampleCallBack;
import com.shuyu.gsyvideoplayer.model.VideoOptionModel;
import com.shuyu.gsyvideoplayer.player.IjkPlayerManager;
import com.shuyu.gsyvideoplayer.player.PlayerFactory;
import com.shuyu.gsyvideoplayer.utils.GSYVideoType;
import com.ubains.rtspdemo.vedio.MultiSampleVideo;
import com.ubains.rtspdemo.vedio.manager.CustomManager;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import tv.danmaku.ijk.media.exo2.Exo2PlayerManager;
import tv.danmaku.ijk.media.exo2.ExoPlayerCacheManager;
import tv.danmaku.ijk.media.player.IjkMediaPlayer;

public class MutliActivity extends AppCompatActivity {

    MultiSampleVideo videoPlayer1, videoPlayer2, videoPlayer3, videoPlayer4;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        //设置全屏
        // getWindow().setFlags(WindowManager.LayoutParams.FLAG_FULLSCREEN, WindowManager.LayoutParams.FLAG_FULLSCREEN);
        //保持屏幕常亮
        getWindow().addFlags(WindowManager.LayoutParams.FLAG_KEEP_SCREEN_ON);

        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.LOLLIPOP) {
            getWindow().requestFeature(Window.FEATURE_CONTENT_TRANSITIONS);
            getWindow().setEnterTransition(new Explode());
            getWindow().setExitTransition(new Explode());
        }
        setContentView(R.layout.activity_mutli);
        videoPlayer1 = findViewById(R.id.detail_player1);
        videoPlayer2 = findViewById(R.id.detail_player2);
        videoPlayer3 = findViewById(R.id.detail_player3);
        videoPlayer4 = findViewById(R.id.detail_player4);
        init();
    }

    private void init() {
        //EXOPlayer内核，支持格式更多
        PlayerFactory.setPlayManager(Exo2PlayerManager.class);
        //系统内核模式
        //PlayerFactory.setPlayManager(SystemPlayerManager.class);
        //ijk内核，默认模式  ijk  模式才支持RTSP 播放
        PlayerFactory.setPlayManager(IjkPlayerManager.class);

        //exo缓存模式，支持m3u8，只支持exo
        // CacheFactory.setCacheManager(ExoPlayerCacheManager.class);
        //代理缓存模式，支持所有模式，不支持m3u8等，默认
        CacheFactory.setCacheManager(ProxyCacheManager.class);
        GSYVideoType.setShowType(GSYVideoType.SCREEN_MATCH_FULL);
        GSYVideoType.setRenderType(GSYVideoType.TEXTURE);


        List<VideoOptionModel> list = new ArrayList<>();
        //设置RTSP 连接方式
        VideoOptionModel videoOptionModel = new VideoOptionModel(IjkMediaPlayer.OPT_CATEGORY_FORMAT, "rtsp_transport", "tcp");
        list.add(videoOptionModel);
        videoOptionModel = new VideoOptionModel(IjkMediaPlayer.OPT_CATEGORY_FORMAT, "rtsp_flags", "prefer_tcp");
        list.add(videoOptionModel);

        //硬解码：1、打开，0、关闭
        videoOptionModel = new VideoOptionModel(IjkMediaPlayer.OPT_CATEGORY_PLAYER, "mediacodec", 1);
        list.add(videoOptionModel);

        //软解码：1、打开，0、关闭
        videoOptionModel = new VideoOptionModel(IjkMediaPlayer.OPT_CATEGORY_PLAYER, "videotoolbox", 1);
        list.add(videoOptionModel);

        //根据媒体类型来配置
        videoOptionModel = new VideoOptionModel(IjkMediaPlayer.OPT_CATEGORY_FORMAT, "allowed_media_types", "video");
        list.add(videoOptionModel);

        videoOptionModel = new VideoOptionModel(IjkMediaPlayer.OPT_CATEGORY_FORMAT, "timeout", 20000);
        list.add(videoOptionModel);
        videoOptionModel = new VideoOptionModel(IjkMediaPlayer.OPT_CATEGORY_FORMAT, "buffer_size", 1316);
        list.add(videoOptionModel);
        videoOptionModel = new VideoOptionModel(IjkMediaPlayer.OPT_CATEGORY_FORMAT, "infbuf", 1);  // 无限读
        list.add(videoOptionModel);
        videoOptionModel = new VideoOptionModel(IjkMediaPlayer.OPT_CATEGORY_FORMAT, "analyzemaxduration", 100);
        list.add(videoOptionModel);
        videoOptionModel = new VideoOptionModel(IjkMediaPlayer.OPT_CATEGORY_FORMAT, "probesize", 4096);
        list.add(videoOptionModel);

        videoOptionModel = new VideoOptionModel(IjkMediaPlayer.OPT_CATEGORY_FORMAT, "analyzeduration", "2000000");
        list.add(videoOptionModel);

        videoOptionModel = new VideoOptionModel(IjkMediaPlayer.OPT_CATEGORY_FORMAT, "flush_packets", 1);
        list.add(videoOptionModel);
        //  关闭播放器缓冲，这个必须关闭，否则会出现播放一段时间后，一直卡主，控制台打印 FFP_MSG_BUFFERING_START
        videoOptionModel = new VideoOptionModel(IjkMediaPlayer.OPT_CATEGORY_PLAYER, "packet-buffering", 0);
        list.add(videoOptionModel);
        GSYVideoManager.instance().setOptionModelList(list);

//        String url = "rtsp://admin:huawei@123@192.168.11.16/LiveMedia/ch1/Media1";
//        String url = "rtsp://admin:huawei@123@192.168.11.16/LiveMedia/ch1/Media2";
//        String url = "rtsp://admin:huawei@123@192.168.11.19/LiveMedia/ch1/Media3";
        String url = "rtsp://admin:HZ0000001988@192.168.10.26:554/h264/ch3/main/av_stream";
        videoPlayer1.setPlayTag("videoPlayer1");
        videoPlayer1.setPlayPosition(1);

        boolean isPlaying = videoPlayer1.getCurrentPlayer().isInPlayingState();

        if (!isPlaying) {
            videoPlayer1.setUpLazy(url, false, null, null, "");
        }


//        videoPlayer1.setRotateViewAuto(true);
//        videoPlayer1.setLockLand(true);
//        videoPlayer1.setReleaseWhenLossAudio(false);
//        videoPlayer1.setShowFullAnimation(true);
//        videoPlayer1.setIsTouchWiget(false);
//        videoPlayer1.setNeedLockFull(true);

        videoPlayer1.startPlayLogic();
//        String ur2 = "rtsp://admin:huawei@123@192.168.11.17/LiveMedia/ch1/Media1";
//        String ur2 = "rtsp://admin:huawei@123@192.168.11.17/LiveMedia/ch1/Media2";

        String ur2 = "rtsp://admin:huawei@123@192.168.11.17/LiveMedia/ch1/Media3";
        videoPlayer2.setPlayTag("videoPlayer2");
        videoPlayer2.setPlayPosition(2);
        boolean isPlaying2 = videoPlayer2.getCurrentPlayer().isInPlayingState();
        if (!isPlaying2) {
            videoPlayer2.setUpLazy(ur2, false, null, null, "");
        }

//        videoPlayer2.setRotateViewAuto(true);
//        videoPlayer2.setLockLand(true);
//        videoPlayer2.setReleaseWhenLossAudio(false);
//        videoPlayer2.setShowFullAnimation(true);
//        videoPlayer2.setIsTouchWiget(false);
//        videoPlayer2.setNeedLockFull(true);
        videoPlayer2.startPlayLogic();

//        String url3 = "rtsp://admin:huawei@123@192.168.11.19/LiveMedia/ch1/Media1";
//        String url3 = "rtsp://admin:huawei@123@192.168.11.19/LiveMedia/ch1/Media2";
//        String url3 = "rtsp://admin:HZ0000001988@192.168.10.21:554/h264/ch1/main/av_stream";
        String url3 = "rtsp://admin:HZ0000001988@192.168.10.28:554/h264/ch1/main/av_stream";

        videoPlayer3.setPlayTag("videoPlayer3");
        videoPlayer3.setPlayPosition(3);
        boolean isPlaying3 = videoPlayer3.getCurrentPlayer().isInPlayingState();
        if (!isPlaying3) {
            videoPlayer3.setUpLazy(url3, false, null, null, "");
        }

//        videoPlayer3.setRotateViewAuto(true);
//        videoPlayer3.setLockLand(true);
//        videoPlayer3.setReleaseWhenLossAudio(false);
//        videoPlayer3.setShowFullAnimation(true);
//        videoPlayer3.setIsTouchWiget(false);
//        videoPlayer3.setNeedLockFull(true);
        videoPlayer3.startPlayLogic();


//        String url4 = "rtsp://admin:huawei@123@192.168.11.19/LiveMedia/ch1/Media1";
//        String url4 = "rtsp://admin:huawei@123@192.168.11.23/LiveMedia/ch1/Media2";
        String url4 = "rtsp://admin:huawei@123@192.168.11.23/LiveMedia/ch1/Media3";
//        String url4 = "rtsp://192.168.1.234:8556/channel=0";

        videoPlayer4.setPlayTag("videoPlayer4");
        videoPlayer4.setPlayPosition(4);
        boolean isPlaying4 = videoPlayer4.getCurrentPlayer().isInPlayingState();
        if (!isPlaying4) {
            videoPlayer4.setUpLazy(url4, false, null, null, "");
        }
        videoPlayer4.setIsTouchWiget(false);

//        videoPlayer4.setRotateViewAuto(true);
//        videoPlayer4.setLockLand(true);
//        videoPlayer4.setReleaseWhenLossAudio(false);
//        videoPlayer4.setShowFullAnimation(true);
//        videoPlayer4.setIsTouchWiget(false);
//        videoPlayer4.setNeedLockFull(true);
        videoPlayer4.startPlayLogic();

    }


    private boolean isPause;

    @Override
    protected void onPause() {
        super.onPause();
        CustomManager.onPauseAll();
        isPause = true;
    }

    @Override
    protected void onResume() {
        super.onResume();
        CustomManager.onResumeAll();
        isPause = false;
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
        CustomManager.clearAllVideo();
    }

}
